using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace ConsoleApp1
{
    class Program
    {
        static int sumniz(List<int> pom)
        {
            int s = 0;
            for (int i = 0; i < pom.Count(); i++)
            {
                s += pom[i];
            }
            return s % (int)(Math.Pow(10, 9) + 7);
        }
        static int suma(int k, List<int> pom)
        {
            int n = pom.Count();
            int pomsum = 0;
            if (k == 0 || n==1) return sumniz(pom);
            else
            {
                for (int i = 0; i < n; i++)
                {
                    List<int> pom1 = new List<int>();
                    for (int j = i; j < n; j++)
                    {
                        pom1.Add(pom[j]);
                    }
                    for (int j = n - i - 1; j >= 0; j--)
                    {
                        pomsum += suma(k - 1, pom1);
                        pomsum = pomsum % (int)(Math.Pow(10, 9) + 7);
                        int ind = pom1.Count - 1;
                        pom1.RemoveAt(ind);
                    }
                }
            }
            return pomsum % (int)(Math.Pow(10, 9) + 7);
        }
        static void Main(string[] args)
        {
            string[] str = Console.ReadLine().Split(' ');
            int n = int.Parse(str[0]);
            int k = int.Parse(str[1]);
            List<int> a = new List<int>();
            str = Console.ReadLine().Split(' ');
            for (int i = 0; i < n; i++)
            {
                a.Add(int.Parse(str[i]));
            }
            Console.WriteLine(suma(k, a));
        }
    }
}